function x = randball(d,n,ref);
% generate n points, randomly distributed in the d-dimensional ball
% according to the reference measure ref (0=uniform, 1=skewed)
%
% output x is d by n

x = randn(d,n);
x = x./repmat(sqrt(sum(x.^2)),d,1); % points uniform on the ball (norm 1)

switch ref
    case 0
        r = (rand(1,n)).^(1/d);
    case 1
        r = (rand(1,n)).^(1/(d+1));
    case 2 % not quite right (attempted donut)
        u = rand(1,n); w = 2*abs(.5-u); r = w.*(u.^(1/d))+(1-w).*(u.^(1/(d+2)));
end

x = x.*repmat(r,d,1);

